﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Logic;
using Entities;

namespace Presentation
{
	public partial class TaskDialogAddGenre : Form
	{
		private bool closing = true;
		private Genre genre = new Genre();

		public Genre Genre
		{
			get { return genre; }
			set { genre = value; }
		}

		public TaskDialogAddGenre()
		{
			InitializeComponent();
		}

		private void buttonCancel_Click(object sender, EventArgs e)
		{
			DialogResult = DialogResult.Cancel;
		}

		private void buttonAdd_Click(object sender, EventArgs e)
		{
			if (textBoxName.Text.Trim() != "")
			{
				genre.Name = textBoxName.Text.Trim();

				GenreBL bl = new GenreBL();
				if (bl.Save(genre))
				{
					MessageBox.Show("The genre was added successfully", "Add genre", MessageBoxButtons.OK, MessageBoxIcon.Information);

					DialogResult = DialogResult.OK;
					closing = true;
				}
				else
					closing = false;
			}
			else
			{
				MessageBox.Show("You need put a name to the genre", "Add genre", MessageBoxButtons.OK, MessageBoxIcon.Warning);
				closing = false;
			}
		}

		private void TaskDialogAddList_FormClosing(object sender, FormClosingEventArgs e)
		{
			if (!closing)
			{
				closing = true;
				e.Cancel = true;
			}
		}
	}
}